<?php
// Copyright (C) <2015>  <it-novum GmbH>
//
// This file is dual licensed
//
// 1.
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, version 3 of the License.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// 2.
//  If you purchased an openITCOCKPIT Enterprise Edition you can use this file
//  under the terms of the openITCOCKPIT Enterprise Edition license agreement.
//  License agreement and license key will be shipped with the order
//  confirmation.

namespace MasterSelfMonitoringModule\Lib\InitialDatabase;

use itnovum\openITCOCKPIT\InitialDatabase\Importer;

/**
 * Class TemplateImport
 * @package MasterSelfMonitoringModule\Lib\InitialDatabase
 */
class TemplateImport extends Importer {
    public function __construct() {
        $TemplateImporter = new \App\itnovum\openITCOCKPIT\ImportTemplates\TemplateImport(
            \Cake\ORM\TableRegistry::getTableLocator()->get('Commands'),
            \Cake\ORM\TableRegistry::getTableLocator()->get('Macros'),
            \Cake\ORM\TableRegistry::getTableLocator()->get('Servicetemplates'),
            \Cake\ORM\TableRegistry::getTableLocator()->get('Hosttemplates'),
            \Cake\ORM\TableRegistry::getTableLocator()->get('Servicetemplategroups')
        );
        $TemplateImporter->import($this->getData());
    }

    public function getData() {
        return [
            'Commands'              => $this->getCommandsData(),
            'Macros'                => $this->getMacrosData(),
            'Hosttemplates'         => $this->getHosttemplatesData(),
            'Servicetemplates'      => $this->getServicetemplatesData(),
            'Servicetemplategroups' => $this->getServicetemplategroupsData()
        ];
    }

    /**
     * @return array
     */
    public function getCommandsData() {
        $data = [
            /*
           [
               'id'               => 'bc922eb4-84ad-44cc-9dff-43a464097753',
               'name'             => 'My awesome command',
               'command_line'     => '$FOO$ this is my command line',
               'command_type'     => '2',
               'human_args'       => null,
           ],
           [
               'id'               => '1ec2b416-a097-4ab7-9365-a898c2bf0a22',
               'name'             => 'another command',
               'command_line'     => 'ls -la $ARG1$ $ARG2$',
               'command_type'     => '1',
               'human_args'       => null,
           ]
          */
        ];
        return $data;
    }

    /**
     * @return array
     */
    public function getMacrosData() {
        $data = [
            /*
            [
                'name'        => '$USER1$',
                'value'       => 'foo',
                'description' => 'bar',
                'password'    => '0',
                'created'     => '2020-05-13 14:11:30',
                'modified'    => '2020-05-13 14:11:30'
            ],
            [
                'name'        => '$USER2$',
                'value'       => 'bar',
                'description' => 'baz',
                'password'    => '0',
                'created'     => '2020-05-13 14:11:41',
                'modified'    => '2020-05-13 14:11:41'
            ]
            */
        ];
        return $data;
    }

    /**
     * @return array
     */
    public function getHosttemplatesData() {
        $data = [
            /*
            [
                'id'                                => '2',
                'uuid'                              => 'd2f712ef-fc7e-4004-9bdc-8c819f00fff',
                'name'                              => 'My Hosttemplate',
                'description'                       => '',
                'hosttemplatetype_id'               => '1',
                'command_id'                        => 'bc922eb4-84ad-44cc-9dff-43a464097753',
                ...
            ],
            [
                'id'                                => '3',
                'uuid'                              => '82e7245a-f1be-41cd-b074-ff88681f7fff',
                'name'                              => 'Another Hosttemplate',
                'description'                       => '',
                'hosttemplatetype_id'               => '1',
                'command_id'                        => 'bc922eb4-84ad-44cc-9dff-43a464097753',
                ...
            ]
            */
        ];
        return $data;
    }

    /**
     * @return array
     */
    public function getServicetemplatesData() {
        $data = [
            /*
           [
               'id'                                        => '80',
               'uuid'                                      => 'f53fa9d1-35a7-46b4-aba7-a30ea6c99a95',
               'template_name'                             => 'My Servicetemplate',
               'name'                                      => 'example servicetemplate name',
               'container_id'                              => '1',
               'servicetemplatetype_id'                    => '1',
              ...
           ],
           [
               'id'                                        => '81',
               'uuid'                                      => '14535db4-9e4e-462d-9c76-0679dc845802',
               'template_name'                             => 'Another Servicetemplate',
               'name'                                      => 'example servicetemplate name',
               'container_id'                              => '1',
               'servicetemplatetype_id'                    => '1',
              ...
           ]
           */
        ];
        return $data;
    }

    public function getServicetemplategroupsData() {
        $data = [
            /*
              [
                'uuid'             => '8125831f-2e20-4f22-a281-afecde2c096e',
                'description'      => 'My servicetemplategroup description',
                'servicetemplates' => [
                    (int)0 => [
                        'id' => '23b76484-6754-44df-9730-5197136e6dda',
                    ]
                ],
                'container'        => [
                    'name'             => 'My awesome servicetemplategroup',
                    'parent_id'        => 1,
                    'containertype_id' => 9
                ]
            ],
            [
                'uuid'             => '35b41de6-fa87-43a6-b8df-36c193a7644d',
                'description'      => 'My servicetemplategroup description',
                'servicetemplates' => [
                    (int)0 => [
                        'id' => 'cfcd95fa-1f4f-48fb-8d80-01bb89194bc8',
                    ]
                ],
                'container'        => [
                    'name'             => 'Another servicetemplategroup',
                    'parent_id'        => 1,
                    'containertype_id' => 9
                ]
            ],
            ...
            */
        ];
        return $data;
    }
}
